#pragma once

#include "Zeichnung.h"
#include "Array.h"

namespace Framework
{
    class Text;
    namespace XML
    {
        class Element;
    }

    class UIMLView : public ZeichnungHintergrund
    {
    private:
        XML::Element *dom;
        RCArray< Zeichnung > *elements;

    public:
        // Erstellt eine UIML View zu einem UIML Text
        //  uiml: Ein xml element gemt des ksg uiml standarts
        __declspec( dllexport ) UIMLView( XML::Element *uiml );
        // Erstellt eine UIML View zu einem UIML Text
        //  uiml: Ein xml text gemt des ksg uiml standarts
        __declspec( dllexport ) UIMLView( Text uiml );
        __declspec( dllexport ) ~UIMLView();
        // setzt den inhalt der view
        //  uiml: Ein xml element gemt des ksg uiml standarts
        __declspec( dllexport ) void setUIML( XML::Element *uiml );
        // setzt den inhalt der view
        //  uiml: Ein xml text gemt des ksg uiml standarts
        __declspec( dllexport ) void setUIML( Text uiml );
        // Gibt eine zeichnung zurck, welche in uiml eine bestimmte id hat
        //  id: die id der Zeichnung
        __declspec( dllexport ) Zeichnung *zZeichnung( Text id );
        // Verarbeitet ein Maus Ereignis. Wird vom Framework automatisch aufgerufen.
        //  me: Das Ereignis
        __declspec( dllexport ) virtual void doMausEreignis( MausEreignis &me );
        // Verarbeitet ein Tastatur Ereignis. Wird vom Framework automatisch aufgerufen
        //  te: Das Ereignis
        __declspec( dllexport ) virtual void doTastaturEreignis( TastaturEreignis &te );
        // Updated den Zeichenhintergrund
        //  tickVal: Die vergangene Zeit in Sekunden, die seit dem Letzten Aufruf dieser Funktion verstrichen ist
        //  return: 1, wenn das Bild neu gezeichnet werden muss. 0 sonnst
        __declspec( dllexport ) bool tick( double tickVal ) override;
        // Zeichnet den Hintergrund eines Zeichnunges nach rObj
        __declspec( dllexport ) void render( Bild &rObj ) override;
    };
}